package pds.xml;

/**
 * XMLTagContent is a class that holds a mapping between a tag name
 * and the content to used for that tag.
 *
 * @author      Todd King
 * @author      Planetary Data System
 * @version     1.0, 10/30/03
 * @since       1.0
 */


class XMLTagContent {
 	/** The name of the tag.
 	 */
	public String	name = "";
	
 	/** The content associated with the start tag. 
 	 */
	public String	start = "";
	
 	/** The content associated with the end tag. 
 	 */
	public String	end = "";
	
	/** The ID number of the tag
	 */
	public int		id = -1;	// -1 is undefined
	 
	/** methods
	 */
	 
	public XMLTagContent(String name) { this.name = name; }
	public XMLTagContent(String name, String start) { this.name = name; this.start = start; }
	public XMLTagContent(String name, String start, String end) { this.name = name; this.start = start; this.end = end; }
}
	
