package pds.ditdos;

import pds.util.PPIOption;
import pds.xml.*;
import java.io.*;
import java.util.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class Ditdos {
	static public class Options {
		// Control parameters
	    String mDatasetID	= null; 
	    String mMission		= null; 
	    String mTarget		= null; 
	    String mProduct		= null; 
	    String mInstrument	= null; 
	    String mTopic		= null; 
	    String mLimit		= null; 
	    String mPossible	= null; 
	    String mPhrase		= null;
	    String mUPI			= null;
	    String mURL			= null;
	    String mPath		= null;
	    String mMime		= null;
	    String mNextTopic	= null; 
	    String mViewing		= null;
	    
	    String	mMessage	= "";	// This is passed between functions
	    
	    // Color theme
		String	mNavNextImage = "/images/navNext.gif";
		String	mNavPrevImage = "/images/navPrev.gif";
				
	    public void normalize() {
        	if(mTopic == null)			mTopic = "F"; 
        	
        	mTopic = mTopic.toUpperCase();
        	
			if(mTopic.length() == 0) mTopic = "F";	// Default
			
			mNextTopic = nextTopic();
	    }	
	
		// Increment the topic to the next instance
		public String nextTopic()
		{
			String	list = "TMIPT";	
			int		n;
			
			n = list.indexOf(mTopic);
			
			return list.substring(n+1, n+2);
		}
    }
        

	static public class MyProperties extends Properties {
		
		public int getPropertyInt(String name) {
			String	prop;
			
			prop = getProperty(name);
			if(prop == null) return 0;
						
			return Integer.parseInt(prop);
		}
		
		public int setPropertyInt(String name, int value) {
			String	prop;
			
			prop = Integer.toString(value);
			setProperty(name, prop);
			
			return value;
		}
		
		public boolean getPropertyBool(String name) {
			String	prop;
			Boolean	bool;
			
			prop = getProperty(name);
			if(prop == null) return false;
			
			bool = Boolean.valueOf(prop);
			return bool.booleanValue();
		}
		
		public boolean setPropertyBool(String name, boolean value) {
			String	prop;
			
			prop = Boolean.toString(value);
			setProperty(name, prop);
			
			return value;
		}
	}
		
	static Connection	mConnection	= null;
	static Statement	mStatement	= null;
	static Options		mOptions = new Options();

	MyProperties		mProperties = new MyProperties();
		
	// Holder for response template
    XMLProcess	xml		= new XMLProcess();
	
	// Configuration parameters
	boolean	debug = true;
	
    int		queryCount = 0;
    
 	/** Creates an instance of a Ditdos object */
 	public Ditdos() {
 		
 		// Define defaults properties
		mProperties.setPropertyInt("PageSize",	20);
		mProperties.setProperty("XMLPathName",	"/var/www/servlet/ditdos.xml");
		mProperties.setProperty("Host",		"128.97.68.59");
		mProperties.setProperty("UserName",	"user");
		mProperties.setProperty("Password",	"pds123");
		mProperties.setProperty("Database",	"pdsppi");
		mProperties.setPropertyBool("Verbose",	false);
		mProperties.setProperty("BaseColor", "#184687");	// Dark blue
		mProperties.setProperty("TextColor", "#FFFFFF");	// White
		mProperties.setProperty("TableColor", "#DDDDDD");	// Grey
		/*
		try {
			mProperties.store(System.out, "DITDOS configuration");
		} catch(Exception e) {
			System.out.println(e.getMessage());
		}
		*/
 	}
 	
    public static void main(String args[]) {
    	String	message;
    	Ditdos	ditdos = new Ditdos();
    	
    	ditdos.setOptions(args);
    	
  	    System.out.println("Ditdos");
  	    
		// Open connection to database
		if((message = ditdos.openDatabase()) != null) {	// Error
			System.out.println(message);
			return;
		}
        
  	    ditdos.xml.setWriter(System.out);
  	    ditdos.processRequest();
  	    
  	    ditdos.closeDatabase();
    }	
  
  /* ------------------------------------------------------------ */
    public void setOption(String name, String value) {
    	String[] args = new String[1];
    	
    	args[0] = name + "=" + value;
    	
    	setOptions(args);
    }
    
  /* ------------------------------------------------------------ */
    public void setVerbose(boolean state) {
		mProperties.setPropertyBool("Verbose", state);
    }
    
  /* ------------------------------------------------------------ */
    public boolean getVerbose()
    { 
    	return mProperties.getPropertyBool("Verbose");
	}
	
  /* ------------------------------------------------------------ */
    public void setOptionsFromProperties(String pathName) {
    	try {
    		FileInputStream stream = new FileInputStream(pathName);
    		mProperties.load(stream);
    		stream.close();
    	} catch(Exception e) {
    		// Do nothin
    	}
    	
    }
    	
  /* ------------------------------------------------------------ */
    public String getOption(String name) {
    	if(name.compareToIgnoreCase("DatasetID") == 0) return mOptions.mDatasetID;
		if(name.compareToIgnoreCase("Mission") == 0) return mOptions.mMission;
		if(name.compareToIgnoreCase("Target") == 0) return mOptions.mTarget;
		if(name.compareToIgnoreCase("Product") == 0) return mOptions.mProduct;
		if(name.compareToIgnoreCase("Instrument") == 0) return mOptions.mInstrument;
		if(name.compareToIgnoreCase("Topic") == 0) return mOptions.mTopic;
		if(name.compareToIgnoreCase("Limit") == 0) return mOptions.mLimit;
		if(name.compareToIgnoreCase("Possible") == 0) return mOptions.mPossible;
		if(name.compareToIgnoreCase("Phrase") == 0) return mOptions.mPhrase;
		if(name.compareToIgnoreCase("UPI") == 0) return mOptions.mUPI;
		if(name.compareToIgnoreCase("URL") == 0) return mOptions.mURL;
		if(name.compareToIgnoreCase("Path") == 0) return mOptions.mPath;
		if(name.compareToIgnoreCase("Mime") == 0) return mOptions.mMime;
		if(name.compareToIgnoreCase("Viewing") == 0) return mOptions.mViewing;
		
		return "";
    }
    
  /* ------------------------------------------------------------ */
    public void setOptionsFromServlet(HttpServletRequest request) {
		// Get passed parameters        
        mOptions.mDatasetID		= getParameter(request, "DatasetID"); 
        mOptions.mMission		= getParameter(request, "Mission"); 
        mOptions.mTarget		= getParameter(request, "Target"); 
        mOptions.mProduct		= getParameter(request, "ProductType"); 
        mOptions.mInstrument	= getParameter(request, "Instrument"); 
        mOptions.mTopic			= getParameter(request, "Topic"); 
        mOptions.mLimit			= getParameter(request, "Limit"); 
        mOptions.mPossible		= getParameter(request, "Possible"); 
        mOptions.mPhrase		= getParameter(request, "Phrase"); 
        mOptions.mUPI			= getParameter(request, "UPI"); 
        mOptions.mPath			= getParameter(request, "Path"); 
        mOptions.mMime			= getParameter(request, "Mime"); 
        
		mOptions.mURL			= request.getRequestURI();        
    }
    
  /* ------------------------------------------------------------ */
    public void setOptions(String args[]) {
    	mOptions.mDatasetID	= PPIOption.find(args, "DatasetID",	mOptions.mDatasetID);
		mOptions.mMission	= PPIOption.find(args, "Mission",	mOptions.mMission);
		mOptions.mTarget	= PPIOption.find(args, "Target",	mOptions.mTarget);
		mOptions.mProduct	= PPIOption.find(args, "ProductType",	mOptions.mProduct);
		mOptions.mInstrument= PPIOption.find(args, "Instrument",	mOptions.mInstrument);
		mOptions.mTopic		= PPIOption.find(args, "Topic",		mOptions.mTopic);
		mOptions.mLimit		= PPIOption.find(args, "Limit",		mOptions.mLimit);
		mOptions.mPossible	= PPIOption.find(args, "Possible",	mOptions.mPossible);
		mOptions.mPhrase	= PPIOption.find(args, "Phrase",	mOptions.mPhrase);
		mOptions.mUPI		= PPIOption.find(args, "UPI",		mOptions.mUPI);
		mOptions.mURL		= PPIOption.find(args, "URL",		mOptions.mURL);
		mOptions.mPath		= PPIOption.find(args, "Path",		mOptions.mPath);
		mOptions.mMime		= PPIOption.find(args, "MIME",		mOptions.mMime);
	}
	
  /* ------------------------------------------------------------ */
    public void setWriter(PrintStream writer) {
    	xml.setWriter(writer);
    }
    
  /* ------------------------------------------------------------ */
    public void setWriter(PrintWriter writer) {
    	xml.setWriter(writer);
    }
    
  /* ------------------------------------------------------------ */
    public void reset() {
    	xml.reset();
    }
    
  /* ------------------------------------------------------------ */
    public void setTag(String name, String content) {
    	xml.setTag(name, content);
    }
    
    
  /* ------------------------------------------------------------ */
    public boolean isDefined(String item)
    { 
    	return (item != null);
	}
	
  /* ------------------------------------------------------------ */
    public boolean hasValue(String item)
    { 
    	if(item == null) return false;
    	if(item.length() > 0) return true;
    	return false;
	}

  /* ------------------------------------------------------------ */
    public String getValue(String item)
    { 
    	if(hasValue(item)) return item;
    	return "";
	}
	
  /* ------------------------------------------------------------ */
    public String queryValue(String item)
    { 
    	if(hasValue(item)) return item;
    	return "%";	// If blank - wild card
	}
	
	// Check if all arguments passed satisfy the requirements
	// for the topic to be displayed
	public boolean isValid()
	{
		if(!hasValue(mOptions.mTopic)) return false;
    	if(hasValue(mOptions.mUPI)) return true;
    	
    	switch(mOptions.mTopic.charAt(0)) {
    	case 'T':	// Target
    		return true;
    	case 'M':	// Mission
    		return true;
    	case 'I':	// Instrument
    		return true;
    	case 'P':	// Product Type
    		return true;
    	case 'F':	// Full text
    		if(hasValue(mOptions.mPhrase)) return true;
    		break;
    	case 'S':	// Sub-item
    		if(hasValue(mOptions.mDatasetID)) return true;
    		break;
    	case 'A':	// Advanced
    		if(hasValue(mOptions.mDatasetID)
    		|| hasValue(mOptions.mMission)
    		|| hasValue(mOptions.mTarget)
    		|| hasValue(mOptions.mProduct)
    		|| hasValue(mOptions.mInstrument)) return true;
    		mOptions.mTopic = "T";
    		break;
    	}
    	return false;
	}
		
    public void processRequest() {
		// Establish database connection        
    	String	message = null;

		String	buffer;
		
		String	url;
		String	query;
		ResultSet	resultSet	= null;
		ResultSetMetaData	meta = null;
		int		tryAndTest;
		FileInputStream	file;
		BufferedReader reader;
		char[]	raw = new char[1024];
		int		n;
		
		long	productCount = 0;
		
		Calendar	queryStart	= new GregorianCalendar();
		Calendar	queryStop	= new GregorianCalendar();
		long		queryElapsed;
		
		queryCount++;
		
		// Initialize persistant variables
		mOptions.mMessage = "";	// Clear message string
		
		// Make sure options are defined properly
		
		mOptions.normalize();
		
		// Deliver file is requested
       	if(hasValue(mOptions.mPath)) {
			try {
				file = new FileInputStream(mOptions.mPath);
				reader = new BufferedReader(new InputStreamReader(file));
				
				while((n = reader.read(raw, 0, 1024)) > 0) {
					xml.write(raw, n);
				}
			} catch(Exception e) {
				xml.message(e.toString());
			}
			
			return;
       	}
        
        System.out.println("Starting query");	
		queryStart.setTime(new java.util.Date());
		
		// We should have a connection to the database server, but if
		// query fails we could have lost it, so try to re-restablish
		tryAndTest = 0;
		while(tryAndTest < 2) {
	        try {
	        	if(mStatement == null) {
	        		xml.message("Unable to connect to database.");
	        		return;
	        	}
	        	
				query = "SELECT COUNT(*) from profile";
		    	resultSet = mStatement.executeQuery(query);
				if(resultSet.first()) {	// Something found - do update
					meta = resultSet.getMetaData();
				    productCount = resultSet.getLong(1);
				}
				resultSet.close();
				tryAndTest = 2;
	        } catch (Exception e) {
	        	if(tryAndTest == 1) {	// Print error message
	        		xml.message("Connecting database: " + e.toString());
	        		tryAndTest = 2;
	        	} else {
	        		closeDatabase();
	        		openDatabase();
	        		tryAndTest = 1;
	        	}
	        }
	     }
		
		try {
			// Define special tags 
			System.out.println("Setting values");
		    xml.setTag("PRODUCTS", 		productCount);
        	xml.setTag("QUERYCOUNT",	"" + queryCount);
        	xml.setTag("DATASETID",		getValue(mOptions.mDatasetID));
        	xml.setTag("MISSION",		getValue(mOptions.mMission));
        	xml.setTag("TARGET",		getValue(mOptions.mTarget));
        	xml.setTag("PRODUCT",		getValue(mOptions.mProduct));
        	xml.setTag("INSTRUMENT",	getValue(mOptions.mInstrument));
        	xml.setTag("TOPIC",			getValue(mOptions.mTopic));
        	xml.setTag("LIMIT",			getValue(mOptions.mLimit));
        	xml.setTag("POSSIBLE",		getValue(mOptions.mPossible));
        	xml.setTag("VIEWING",		getValue(mOptions.mViewing));
        	
        	xml.setTag("BRAND",			"<H1>DITDOS</H1>");
        	xml.setTag("HEADER",		makeHeader("DITDOS"));
        	xml.setTag("QUERYFORM",		makeForm());
        	xml.setTag("FOOTER",		makeFooter("DITDOS"));
		
			System.out.println("Running query");
        	// Run query to return results
        	if(isValid()) {
        		System.out.println("Options are valid");
        		processQuery();
        	
        		// Generate post query tags
		    	queryStop.setTime(new java.util.Date());
		    	queryElapsed = queryStop.getTimeInMillis() - queryStart.getTimeInMillis();
		    	buffer = "<font size=-1>Viewing " + mOptions.mViewing 
		      	   + "; Searched <B>" + productCount + "</B> products in <B>" 
		    	   + (queryElapsed / 1000.0) + "</B> seconds.</font>";
		  	} else {
		  		buffer = "";
		  	}
        	xml.setTag("MENU",		makeMenu(buffer));
        	xml.setTag("MESSAGE",	mOptions.mMessage);
        	
        	// Now generate the HTML
			xml.process(mProperties.getProperty("XMLPathName"));
        } catch (Exception e) {
            xml.message("Processing request: " + e.toString());
        }
    }
    
    public void processQuery()
    {
    	String		query;
		ResultSet	resultSet	= null;
    	
    	if(mStatement == null) return;	// Not possible to proceed

    	// Construct query
    	// query = makeQuery(options);
    	// xml.setTag("QUERY", query);
    	// xml.setTag("DEBUG", "Target: " + mOptions.mTarget + "<BR>Form: " + mOptions.mForm);
    	
		// Now try to execute it
		try {
			doSourceInfoQuery();
	    	// Construct query
			query = makeQuery();
			xml.setTag("QUERY", query);
			
	    	resultSet = mStatement.executeQuery(query);
			if(resultSet.last()) {	// Something found - retrieve results
				makePageList(resultSet);
				// Now process the query
				doQuery(resultSet);
			} else {	// Nothing found
				xml.setTag("RESULTS", "No matches");
			}
			resultSet.close();
        } catch (Exception e) {
            xml.message("Processing query: " + e.toString());
        }
	}
	
	public boolean isMetaQuery()
	{
		if(hasValue(mOptions.mTopic) && mOptions.mTopic.charAt(0) == 'S') return false;
		if(hasValue(mOptions.mUPI)) return false;
		
		return true;
	}
	

	public boolean isProductQuery()
	{
		if(hasValue(mOptions.mDatasetID)) return true;
		if(hasValue(mOptions.mUPI)) return true;
		if(hasValue(mOptions.mPath)) return true;
		
		return false;
	}
		
	public boolean isCrossQuery()
	{
		if(isDefined(mOptions.mInstrument)
		&& isDefined(mOptions.mMission)
		&& isDefined(mOptions.mProduct)
		&& isDefined(mOptions.mTarget)) return true;
		
		return false;
	}
	

	public void makePageList(ResultSet resultSet)
	{
    	String		buffer;
    	String		query;
    	String		parameters;
    	String		url;
    	String		color;
    	String		temp;
    	boolean		hot;
		ResultSetMetaData	meta = null;
		
    	int			n, i, j, k;
    	int			first;
    	int			start;
    	int			rows;
    	int			totalPages;
    	int			possible;
    	int			currentPage;
    	int			maxShowPage	= 10;	// Maximum list of pages to show
    	int			pageSize = mProperties.getPropertyInt("PageSize");
    	
		try {
			meta = resultSet.getMetaData();
			
            // xml.message("Possible range<BR>");
			possible = resultSet.getRow();
			if(hasValue(mOptions.mPossible)) {	// Determine the maximum number of rows
				possible = Integer.parseInt(getValue(mOptions.mPossible));
			}
		
			// Indicate number of pages available
			// We show the 10 "nearest" pages to the current
			parameters = makeURLParameters(true);
			n = possible / pageSize;
			if(n * pageSize < possible) n++;
			
			if(hasValue(mOptions.mLimit))  first = Integer.parseInt(getValue(mOptions.mLimit));
			else	first = 0;
			currentPage = first / pageSize;
			first -= pageSize;	// Reduce by one page
			if(first < 0) first = 0;
			if(n <= 10) start = 0;	// Always show all pages
			else start = first / pageSize;	// Determine first page to show
			
			totalPages = n;
			if(start < (n - maxShowPage)) {	// If there's more than 10 remaining entries
			// Reduce the number of pages shown
				n = maxShowPage;
			}
			
			// Create page lists
            buffer = "<TABLE><TR>";
			buffer += "<TD>Page:</TD>";
			if(start > 0) {
				i = start - maxShowPage;
				if(i < 0) i = 0;
				url = makeURL(i*pageSize, possible, parameters);
				buffer	+= "<TD><a href=\"" + url + "\">&nbsp;"
						+ "<img alt=\"Previous\" BORDER=0 href=\"" + mOptions.mNavPrevImage + "\"></a></TD>";
			}
			for(i = 0; i < n; i++) {
				if(start+i == currentPage) { color = mProperties.getProperty("BaseColor"); hot =true; }
				else { color = "#FFFFFF";	hot = false; } // White
				url = makeURL((start+i)*pageSize, possible, parameters);
			    buffer += "<TD BGCOLOR=\"" + color + "\">";
			    if(!hot) buffer += "<a href=\"" + url + "\">";
			    buffer += "&nbsp;" + makeText(Integer.toString(start+i+1), hot);
			    if(!hot) buffer += "</a></TD>";
			}
			if(n < totalPages) {
				url = makeURL((start+n)*pageSize, possible, parameters);
				buffer	+= "<TD><a href=\"" + url + "\">&nbsp;"
						+ "<img alt=\"Next\" BORDER=0 href=\"" + mOptions.mNavNextImage + "\"></a></TD>";
			}
			buffer += "</TR></TABLE>";
			xml.setTag("PAGELIST", buffer);
        } catch (Exception e) {
            xml.message("Processing query: " + e.toString());
        }
	}
					
	public void doSourceInfoQuery()
	{
		String				buffer;
		String				query;
		ResultSet			resultSet;
		ResultSetMetaData	meta = null;
		int		i;
		int		rows;

		xml.setTag("DESCRIPTION", "");
		if(mStatement == null) return;
		if(!hasValue(mOptions.mUPI)) { return; }
		
		try {
			query = "SELECT DISTINCT Description FROM product WHERE UPI = " + getValue(mOptions.mUPI) + " GROUP BY UPI";
	    	resultSet = mStatement.executeQuery(query);
			
			meta = resultSet.getMetaData();
						
			// Create results
			rows = resultSet.getRow();
			buffer = getValue(mOptions.mUPI) + "<BR>";
			
			resultSet.first();
			for(i = 0; i < rows; i++) {
				buffer += resultSet.getString(1);
			}
			buffer += "<BR>";
			xml.message("buffer: " + buffer);
			xml.setTag("DESCRIPTION", buffer);
        } catch (Exception e) {
            xml.message("Processing meta query: " + e.toString());
        }
		
		return;
	}

	public boolean doQuery(ResultSet resultSet)
	{
		String				parameters;
		ResultSetMetaData	meta = null;
		String				buffer;
		String				viewing;
		String				text;
		String				url;
		String				upi = "";
		
		int		i, j, k, n;
		int		rows;
		int		possible;
		int		first = 1;
		boolean	product;
		int		pageSize = mProperties.getPropertyInt("PageSize");
		
		product = isProductQuery();

		if(product) first = 2;
		
		try {
			meta = resultSet.getMetaData();
						
		    // xml.message("Possible range<BR>");
			possible = resultSet.getRow();
			if(hasValue(mOptions.mPossible)) {	// Determine the maximum number of rows
				possible = Integer.parseInt(getValue(mOptions.mPossible));
			}
			
			// Determine what we are currently viewing	
			rows = resultSet.getRow();
			if(rows > pageSize) rows = pageSize;
			
			if(hasValue(mOptions.mLimit)) { i = Integer.parseInt(mOptions.mLimit); k = i + pageSize; if(k > possible) k = possible; }
			else { i = 1; k = rows; }
			
			viewing = "<b>" + i + " </b>-<b> " + k + "</b>";
			viewing += " of <b>";
			
			if(hasValue(mOptions.mPossible)) viewing += mOptions.mPossible;
			else viewing += resultSet.getRow();
			
			viewing += "</b>";
			mOptions.mViewing = viewing;
			
			n = meta.getColumnCount();
			buffer = "<TABLE>";
			
			// Show results.
			// Create table heading
			buffer += "<TR bgcolor=\"" + mProperties.getProperty("BaseColor") + "\">";
			for(i = first; i <= n; i++) {
				buffer += "<TD align=\"center\">" + makeText(properCase(meta.getColumnName(i))) + "</TD>";
			}
			buffer += "</TR>";
					
			// Populate with data
	        // First field contains UPI (or path), which is not shown
			parameters = makeURLParameters(false);
			resultSet.first();
			for(i = 0; i < rows; i++) {
  			    buffer += "<TR bgcolor=\"" + mProperties.getProperty("TableColor") + "\">";
				for(j = 1; j <= n; j++) {
					if(product && j == 1) { upi = resultSet.getString(j); continue;}
					if(meta.getColumnType(j) == java.sql.Types.VARCHAR) buffer += "<TD>";
					else buffer += "<TD ALIGN=\"RIGHT\">";	// Right align non-text
					if(j == first) {	// Mark first item with URL
						if(product) {
							if(hasValue(mOptions.mUPI)) { // Then its a piece of a product - upi is path
								url = getValue(mOptions.mURL) + "?Path=" + upi + "&Mime=" + resultSet.getString(n);
							} else {	// Then its a whole product
								url = getValue(mOptions.mURL) + "?UPI=" + upi;
							}
						} else {
							url = getValue(mOptions.mURL) + "?" + properCase(meta.getColumnName(j)) + "=" + resultSet.getString(j);
							if(parameters.length() > 0) url += "&" + parameters;
						}
					} else {
						url = "";
					}
					if(url.length() > 0) buffer += "<a href=\"" + url + "\">";
					
					text = "";
					switch(meta.getColumnType(j)) {
						case java.sql.Types.TIMESTAMP: text += resultSet.getTimestamp(j); break;
						default: text += resultSet.getString(j); break;
					}
					if(text.length() == 0) text = "Unknown";
					buffer += text;
					if(url.length() > 0) buffer += "</a>";
					buffer += "</TD>";
				}
				buffer += "</TR>";
				resultSet.next();
			}
			buffer += "</TABLE>";
			xml.setTag("RESULTS", buffer);
        } catch (Exception e) {
            xml.message("Processing product query: " + e.toString());
        }
		
		return true;
	}

	// A case insensitive and partial match version of ServletRequest.getParameter()
	// Returns null if parameter not found
	public String getParameter(HttpServletRequest request, String name)
	{
		Enumeration	e;
		String		value = null;
		String		paramName;
		String		tempName;
		String		upperName;
		int			n;
		
		if(name.length() == 0) return null;

		e = request.getParameterNames();
		while(e.hasMoreElements()) {
			paramName = (String) e.nextElement();
			if(name.compareToIgnoreCase(paramName) == 0) {	// Exact match
				value = request.getParameter(name);
			} else if(value == null) {	// Check for partial match
				n = name.length();
				tempName = paramName;
				if(tempName.length() > n) tempName = tempName.substring(0, n);
				if(name.compareToIgnoreCase(tempName) == 0) {
					value = request.getParameter(paramName);
				}
			}
		}
		
		return value;
	}
	
	// Convert a string to proper case
	public String properCase(String text)
	{
		String	proper;
		
		if(text.length() == 0) return text;
		// text = text.toLowerCase();
		proper = Character.toString(text.charAt(0));
		proper = proper.toUpperCase();
		
		if(text.length() > 1) proper += text.substring(1);
		return proper;
	}
	
	// Create a string containing a properly constructed URL
	public String makeURL(int limit, int possible, String parameters)
	{
		String	url;
		
		url = getValue(mOptions.mURL) + "?Limit=" + limit;
		url += "&Possible=" + possible;
		if(parameters.length() > 0) url += "&" + parameters;
		
		return url;

	}
	
	// Create a string containing URL parameters
	public String makeURLParameters(boolean page)
	{
		return makeURLParameters(page, false);
	}	
	
	// Create a string containing URL parameters
	public String makeURLParameters(boolean page, boolean subItem)
	{	
		String	parameters	= "";
		String	delim		= "";
		boolean	productSearch	= false;
		
		if(subItem) {	// Switch to product search mode
			parameters += delim + "Topic=S";
			delim = "&";
			if(hasValue(mOptions.mDatasetID)) {
				parameters += delim + "DatasetID=" + getValue(mOptions.mDatasetID);
			}
		} else {
			if(hasValue(mOptions.mTopic)) {
				parameters += delim + "Topic=";
				if(page) parameters += getValue(mOptions.mTopic);
				else parameters += getValue(mOptions.mNextTopic);
				delim = "&";
			}
			if(isDefined(mOptions.mInstrument)) {
				parameters += delim + "Instrument=" + getValue(mOptions.mInstrument);
				delim = "&";
			}
			if(isDefined(mOptions.mMission)) {
				parameters += delim + "Mission=" + getValue(mOptions.mMission);
				delim = "&";
			}
			if(isDefined(mOptions.mProduct)) {
				parameters += delim + "ProductType=" + getValue(mOptions.mProduct);
				delim = "&";
			}
			if(isDefined(mOptions.mTarget)) {
				parameters += delim + "Target=" + getValue(mOptions.mTarget);
				delim = "&";
			}
			if(isDefined(mOptions.mDatasetID)) {
				parameters += delim + "DatasetID=" + getValue(mOptions.mDatasetID);
				delim = "&";
			}
			if(isDefined(mOptions.mPhrase)) {
				parameters += delim + "Phrase=" + getValue(mOptions.mPhrase);
				delim = "&";
			}
		}
		
		return parameters;
	}

	public String makeQuery()
	{	
		String	query = "";
		String	table = "";
		String	where = "";
		String	limit = "";
		String	order = "";
		String	group = "";
		String	delim = "";
		String	plus = "";
		String	count = "";
		String	buffer;
		
		int			i;
		Character	c;
		String		action = "";
    	int			pageSize = mProperties.getPropertyInt("PageSize");
		
		mOptions.mMessage = "";
		
		// Built-up count and where clause
		if(isDefined(mOptions.mPhrase)) {	// If "phrase" is present doing a full text search
			mOptions.mMessage = getValue(mOptions.mPhrase);
			action 	= "DISTINCT DatasetID, Description, DATE_FORMAT(MIN(StartTime), '%Y-%m-%d %H:%i:%s') as StartTime,"
					+ " DATE_FORMAT(MAX(StopTime), '%Y-%m-%d %H:%i:%s') as StopTime"; 
			buffer = " MATCH(description,words) AGAINST( '" + getValue(mOptions.mPhrase) + "')";
			count = " ROUND(" + buffer + ", 1) as 'Score'";
			where = " WHERE" + buffer;
			order = "Score DESC";
			group = "DatasetID"; 
			table = "product"; 
		} else if(isDefined(mOptions.mDatasetID)) {	// If "DatasetID" is present retrieve dataset
			mOptions.mMessage = getValue(mOptions.mDatasetID);
			action 	= "UPI, ProductID, Orbit, StartTime, StopTime"; 
			where = " WHERE DatasetID LIKE '" + queryValue(mOptions.mDatasetID) + "'";
			count = "";
			order = "";
			group = ""; 
			table = "product"; 
		} else if(isDefined(mOptions.mUPI)) {	// If "UPI" is present retrieve dataset
			mOptions.mMessage = getValue(mOptions.mDatasetID);
			action 	= "Path, Name, TimeStamp, Size, MIME"; 
			where = " WHERE UPI = " + queryValue(mOptions.mUPI);
			count = "";
			order = "";
			group = ""; 
			table = "source"; 
		} else {	// Individual constraints
			where = "";
			delim = "";
			plus = "";
			if(isDefined(mOptions.mInstrument)) {
				where += delim + " profile.Instrument LIKE '" + queryValue(mOptions.mInstrument) + "'";
				mOptions.mMessage += plus + getValue(mOptions.mInstrument);
				delim = " AND";
				plus = "->";
			}
	
			if(isDefined(mOptions.mMission)) {
				where += delim + " profile.Mission LIKE '" + queryValue(mOptions.mMission) + "'";
				mOptions.mMessage += plus + getValue(mOptions.mMission);
				delim = " AND";
				plus = "->";
			}
	
			if(isDefined(mOptions.mProduct)) {
				where += delim + " profile.ProductType LIKE '" + queryValue(mOptions.mProduct) + "'";
				mOptions.mMessage += plus + getValue(mOptions.mProduct);
				delim = " AND";
				plus = "->";
			}
	
			if(isDefined(mOptions.mTarget)) {
				where += delim + " profile.Target LIKE '" + queryValue(mOptions.mTarget) + "'";
				mOptions.mMessage += plus + getValue(mOptions.mTarget);
				delim = " AND";
				plus = "->";
			}
			
			if(isCrossQuery()) {
				where += delim + " profile.UPI = product.UPI";
			}
		
			if(where.length() > 0) where = " WHERE " + where;
			
			// Now determine what to return
			count = "";
			order = "";
			group = "";
			action = "";
			if(isProductQuery()) {
				action 	= "UPI, ProductID, Orbit, StartTime, StopTime"; 
				table = "product";
			} else if(isCrossQuery()) {
				action 	= "product.UPI as UPI, ProductID, Orbit, StartTime, StopTime"; 
				table = "product, profile";
			} else {
				count = "COUNT(*) as 'Products'";
				table = "profile";
		
		    	if(hasValue(mOptions.mTopic)) {
			    	switch(mOptions.mTopic.charAt(0)) {
					case 'I':	// Instrument
						action = group = "Instrument";
						break;
					case 'M':	// Mission
						action = group = "Mission";
						break;
					case 'P':	// Product Type
						action = group = "ProductType";
						break;
					case 'T':	// Target
						action = group = "Target";
						break;
					case 'D':	// DatasetID
						action = group = "DatasetID";
						break;
					case 'F':	// Full text
						break;
					}
				}
				if(action.length() == 0) action = group = "Target";	// Default
			}
		}
					
		limit = "";
		if(hasValue(mOptions.mLimit)) {
			limit = " limit " + getValue(mOptions.mLimit) + "," + pageSize;
		}
		if(group.length() > 0) group = " group by " + group;
		if(table.length() > 0) table = " from " + table;
		if(count.length() > 0) count = ", " + count;
		if(order.length() > 0) order = " ORDER BY " + order;
		
		query = "SELECT " + action + count + table + where + group + order + limit;
		
		return query;
	}
		
    public String makeForm() 
    {    
    	String	buffer = "";
    	
    	if(!hasValue(mOptions.mTopic)) return buffer;
    	
    	switch(mOptions.mTopic.charAt(0)) {
    	case 'A':	// Advanced
    		buffer	= "<FORM name=\"try\" method=\"post\" action=\"" + mOptions.mURL + "\">\n"
    				+ "Dataset ID: <INPUT type=\"text\" name=\"DatasetID\" value=\"" + getValue(mOptions.mDatasetID) + "\"><BR>\n"
    				+ "OR<BR>\n"
    				+ "Mission: <INPUT type=\"text\" name=\"Mission\" value=\"" + getValue(mOptions.mMission) + "\"><BR>\n"
    				+ "Target: <INPUT type=\"text\" name=\"Target\" value=\"" + getValue(mOptions.mTarget) + "\"><BR>\n"
    				+ "Instrument: <INPUT type=\"text\" name=\"Instrument\" value=\"" + getValue(mOptions.mInstrument) + "\"><BR>\n"
    				+ "Product Type: <INPUT type=\"text\" name=\"ProductType\" value=\"" + getValue(mOptions.mProduct) + "\"><BR>\n"
    				+ "<INPUT type=\"hidden\" name=\"Topic\" value=\"" + getValue(mOptions.mTopic) + "\">\n"
    				+ "<INPUT type=\"hidden\" name=\"Limit\" value=\"" + getValue(mOptions.mLimit) + "\">\n"
    				+ "<INPUT type=\"hidden\" name=\"Possible\" value=\"" + getValue(mOptions.mPossible) + "\">\n"
    				+ "<INPUT type=\"submit\" name=\"Submit\" value=\"Submit\">\n"
    				+ "</FORM>\n";
    				;
    		break;
    	case 'F':	// Full Text
    		buffer	= "<FORM name=\"try\" method=\"post\" action=\"" + getValue(mOptions.mURL) + "\">\n"
    				+ "Words: <INPUT type=\"text\" name=\"Phrase\" value=\"" + getValue(mOptions.mPhrase) + "\"><BR>\n"
    				+ "<INPUT type=\"hidden\" name=\"Topic\" value=\"" + getValue(mOptions.mTopic) + "\">\n"
    				+ "<INPUT type=\"hidden\" name=\"Limit\" value=\"" + getValue(mOptions.mLimit) + "\">\n"
    				+ "<INPUT type=\"hidden\" name=\"Possible\" value=\"" + getValue(mOptions.mPossible) + "\">\n"
    				+ "<INPUT type=\"hidden\" name=\"Submit\" value=\"Submit\">\n"
    				+ "</FORM>\n";
    				;
    		break;
    	}
    	
    	return buffer;
    }
    
        	
    public String makeHeader(String title) 
    {    
    	String	buffer;
    	
    	buffer	= "<HTML>\n"
    			+ "<HEAD>\n"
    			+ "<TITLE>" + title + "</TITLE>"
    			+ "</HEAD>\n"
    			+ "<BODY>\n"
    			;
    			
    	return buffer;
    }
    
    public String makeFooter(String copyright) 
    {    
    	String	buffer;
    	
    	buffer	= "<BR><CENTER><FONT SIZE=\"-2\">" + copyright + "</FONT></CENTER>\n"
    			+ "</BODY>\n"
    			+ "</HTML>\n"
    			;
    			
    	return buffer;
    }
    
    public String makeMenu(String search) 
    {    
    	String	buffer;
    	String	delim;
    	
    	String	selectColor = mProperties.getProperty("BaseColor");
    	String	plainColor = "#FFFFFF";		// White
    	String	targetColor = plainColor;
    	boolean	targetHot = false;
    	String	missionColor = plainColor;
    	boolean	missionHot = false;
    	String	productColor = plainColor;
    	boolean	productHot = false;
    	String	instrumentColor = plainColor;
    	boolean	instrumentHot = false;
    	String	searchColor = plainColor;
    	boolean	searchHot = false;
    	String	advancedColor = plainColor;
    	boolean	advancedHot = false;
    	
    	// Determine menu states
    	if(hasValue(mOptions.mTopic)) {
	    	switch(mOptions.mTopic.charAt(0)) {
	    	case 'T':	// Target
	    		targetColor = selectColor;
	    		targetHot = true;
	    		break;
	    	case 'M':	// Mission
	    		missionColor = selectColor;
	    		missionHot = true;
	    		break;
	    	case 'I':	// Instrument
	    		instrumentColor = selectColor;
	    		instrumentHot = true;
	    		break;
	    	case 'P':	// Product Type
	    		productColor = selectColor;
	    		productHot = true;
	    		break;
	    	case 'F':	// Free text
	    		searchColor = selectColor;
	    		searchHot = true;
	    		break;
	    	case 'A':	// Advanced
	    		advancedColor = selectColor;
	    		advancedHot = true;
	    		break;
	    	}
	    } else {
	    	mOptions.mMessage = "Select a search method from the list above.";
	    }
    	
    	buffer	= "<TABLE BORDER=\"0\" BGCOLOR=\"" + mProperties.getProperty("BaseColor") + "\">\n"
				+ "<TR>\n"
				+ "<TD BGCOLOR=\"" + searchColor + "\" ><A class=\"menuLink\" href=\"" + mOptions.mURL + "?Topic=F\">&nbsp;" + makeText("Search", searchHot) + "&nbsp;</A></TD>\n"
				+ "<TD BGCOLOR=\"" + targetColor + "\"><A class=\"menuLink\" href=\"" + mOptions.mURL + "?Topic=T\">&nbsp;" + makeText("Target", targetHot) + "&nbsp;</A></TD>\n"
				+ "<TD BGCOLOR=\"" + missionColor + "\"><A class=\"menuLink\" href=\"" + mOptions.mURL + "?Topic=M\">&nbsp;" + makeText("Mission", missionHot) + "&nbsp;</A></TD>\n"
				+ "<TD BGCOLOR=\"" + instrumentColor + "\"><A class=\"menuLink\" href=\"" + mOptions.mURL + "?Topic=I\">&nbsp;" + makeText("Instrument", instrumentHot) + "&nbsp;</A></TD>\n"
				+ "<TD BGCOLOR=\"" + productColor + "\"><A class=\"menuLink\" href=\"" + mOptions.mURL + "?Topic=P\">&nbsp;" + makeText("Product&nbsp;Type", productHot) + "&nbsp;</A></TD>\n"
				+ "<TD BGCOLOR=\"" + advancedColor + "\"><A class=\"menuLink\" href=\"" + mOptions.mURL + "?Topic=A\">&nbsp;" + makeText("Advanced", advancedHot) + "&nbsp;</A></TD>\n"
				+ "</TR>\n"
				+ "</TABLE>"
				+ "<TABLE WIDTH=\"100%\" BORDER=\"0\" BGCOLOR=\"" + mProperties.getProperty("BaseColor") + "\">\n"
				+ "<TR BGCOLOR=\"" + selectColor + "\">\n"
				+ "<TD COLSPAN=\"6\" ALIGN=\"LEFT\">" + makeText(mOptions.mMessage) + "&nbsp;</TD>\n"
				+ "<TD ALIGN=\"RIGHT\">" + makeText(search) + "</TD>\n"
				+ "</FONT>"
				+ "</TR>\n"
				+ "</TABLE>"
				;
		
		return buffer;
    }

	public String makeText(String text)
	{
		return makeText(text, true);
	}
	
	public String makeText(String text, boolean hot)
	{
		String buffer = "";
		
		if(hot) buffer += "<font color=\"" + mProperties.getProperty("TextColor") + "\">";
		buffer += text;
		if(hot) buffer += "</font>";
		
		return buffer;
	}
	
	public String openDatabase()
	{    
		String	host		= mProperties.getProperty("Host");
		String	database	= mProperties.getProperty("Database");
		String	username	= mProperties.getProperty("UserName");
		String	password	= mProperties.getProperty("Password");
		
		String	DBUrl = "jdbc:mysql://" + host + "/" + database;
		String	message = null;
		
        try {
            Class.forName("com.mysql.jdbc.Driver").newInstance();
            
            mConnection = DriverManager.getConnection(DBUrl, username, password);
            if(mConnection == null) {
            	message = "Creation of connection to database failed...";
            } else {
       			mStatement = mConnection.createStatement(
                                      ResultSet.TYPE_SCROLL_SENSITIVE,
                                      ResultSet.CONCUR_UPDATABLE);
                if(mStatement == null) {
                	message = "Create of query statement failed...";
                }
            }
        } catch (Exception e) {
            message = "Opening database: " + e.toString();
            closeDatabase();
        }
        
        return message;
    }
    
    public boolean closeDatabase()
    {
        if (mStatement != null) {
            try {
                mStatement.close();
                mStatement = null;
            } catch (SQLException SQLE) {
            	// trouble closing statment
            }
        }
        if (mConnection != null) {
            try {
                mConnection.close();
                mConnection = null;
            } catch (SQLException SQLE) {
            	// trouble closing connection
            }
        }
		return true;
    }
}

